package tree

/*
	These code should be common to all gui plugins

	There are some helper functions that are probably going to be
	the same everywhere. Mostly due to handling the binary tree structure
	and the channel communication
*/

import (
	"os"
	"time"

	"go.wit.com/log"
	"go.wit.com/widget"
)

func (me *TreeInfo) InitOK() {
	me.ok = true
}

// this hack is to wait for the application to send something
// before trying to do anything. todo: rethink this someday
func (me *TreeInfo) WaitOK() {
	for {
		if me == nil {
			log.Info("WaitOK lied. me == nil but returned anyway")
			log.Info("WaitOK lied. me == nil but returned anyway")
			log.Info("WaitOK lied. me == nil but returned anyway")
			os.Exit(-1)
		}
		if me.ok {
			return
		}
		time.Sleep(10 * time.Millisecond)
	}
}

// Other goroutines must use this to access the GUI
//
// You can not acess / process the GUI thread directly from
// other goroutines. This is due to the nature of how
// Linux, MacOS and Windows work (they all work differently. suprise. surprise.)
//
// this sets the channel to send user events back from the plugin
func (me *TreeInfo) Callback(guiCallback chan widget.Action) {
	me.callback = guiCallback
}

// this is the function that receives things from the application
func (me *TreeInfo) PluginChannel() chan widget.Action {
	me.WaitOK()
	return me.pluginChan
}

// this is the function that receives things from the application
func (me *TreeInfo) FrozenChannel() chan widget.Action {
	return me.frozenChan
}
